<?PHP

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.5.02  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@gmail.com)
* Forms builder module : 
* index.php: last changed 20/02/2007 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

define('IN_SAS', true);
define('SAS_VERSION', '3.0.00');

$old_error_reporting = error_reporting(0); // switch off error reporting during sanity checks

function error_exit($conditioncode, $ttl = "Error")
{
	/*---------------------------------
	 * Show a 'cryptic' condition code + exit
	 */
	echo "<html>\n<head>\n<title>$ttl</title>\n</head>\n<body>\n" .
	"<h1>$ttl</h1>\n" .
	"<b>There is a problem with this site.</b>\n<p>\n" .
	"Please contact the site owner mentioning the " .
	"following condition code:\n<p>\n<b>" .
	SAS_VERSION . '/' . $conditioncode . "</b>\n<p>\n" .
	"Thank you for your cooperation!\n</body>\n</html>\n";
	exit;
} /* error_exit() */

// SANITY CHECK #1 - is there an existing installation at the location we expect?
if (!file_exists('configuration/database.inc.php'))
{
	error_exit('010');
}

//- do we have a connection to a working database?
include ('configuration/database.inc.php');
$db = new mysqli($db_server, $db_username, $db_password, $db_name);

require ("core/session.php"); //build a session

include ("core/common.inc.php"); //include common functions

unset ($sas_config); //clear the config array first
$query = "SELECT config_key,config_value FROM $table_configuration";
//read all the configuration items.

$result = mysqli_query($db,$query);
while ($config_list = mysqli_fetch_array($result))
{
	$sas_config[$config_list[0]] = $config_list[1]; //put them in the config array
}

if ($sas_config['sessioncode'] == "")
{
	error_exit('060');
}
error_reporting($old_error_reporting); // switch on error reporting after sanity checks
//from here on we should be able to mail other errors to the site admin.
//so set our own error handler (in common.inc.php)
set_error_handler('myErrHandler');

if (IsSet ($_REQUEST['option']))
{
	$option = htmlspecialchars(strip_tags($_REQUEST['option']));
}
else
{
	unset ($option);
}

if (IsSet ($_SESSION['userid']))
{
	$userid = $_SESSION['userid'];
	$access = $_SESSION['access'];
}
else
{
	unset ($userid);
}

$check_sessioncode = $sas_config['sessioncode'];
$site_url = $sas_config['url'];
$userpath = $sas_config['user_path']; //get the directoryname of the cms
if (substr($userpath, 0, 1) == "/")
{
	$userpath = substr($userpath, 1); //strip first slash
}

$serverpath = $sas_config['serverpath']; //get the document root of the site
if (strrpos($serverpath, '/') != strlen($serverpath) - 1)
{
	$serverpath .= '/'; //add last slash if not present
}

$date_format = $sas_config['dateformat'];
$serverpath = $serverpath . $userpath;
$sitename = $sas_config['sitename'];
$cmsdir = substr(strrchr($serverpath, "/"), 1); //get the directoryname of the cms
$media = $sas_config['media_dir']; //media directory
$studentpages = $sas_config['studentpages_dir']; //pupilpages directory

$language = $sas_config['language'];
load_language('', ''); //load language file

if (($option == "userlogin") OR ($option == "save_new_password"))
{
	if (IsSet ($_POST['user_username']))
	{
		$user = sanitize($_POST['user_username'], 20, 'A');
	}
	if (IsSet ($_POST['user_username']))
	{
		$password = sanitize($_POST['user_password'], 20, 'A');
	}
	
	if (!verify_logon($user, $password, $option))
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"" . $sas_lang['login_error'] . "\");
			   window.location = 'index.php' ;	
			   //-->
			   </script>";
	}
}

//if we don't have a session or usertype smaller than 20 (1 pupil and 2 teacher) do not have access.
if ((!isset ($_SESSION['sessioncode'])) AND ($_SESSION['sessioncode'] != $sas_config['sessioncode']) OR (intval($_SESSION['user_type']) < 20))
{
	include ("interface/saslogin.inc.php");
}
else
{
	switch ($option)
	{
		default :
			include ("core/startcenter.inc.php");
		break;

		case "pagemanager" :
			include ("core/pagemanager.inc.php");
		break;

		case "modulemanager" :
			include ("core/modulemanager.inc.php");
		break;

		case "filemanager" :
			include ("core/filemanager.inc.php");
		break;

		case "configuration" :
			include ("core/configuration.inc.php");
		break;

		case "tools" : // tools
			include ("core/tools.inc.php");
		break;

		case "stats" : // statistics
			include ("core/stats.php");
		break;

		case "logout" :

			session_destroy();
			if ($_SESSION['user_type'] == 20)
			{
				header("location: index.php");
			}
			else
			{
				header("location: ../index.php");
			}
			
		break;
	}
}
?>